// WINHELP.INI Reference Resolver

// Unsupported freeware

// Copyright 1996 by Ralph Smith. All rights reserved.

// e-mail: rsmith@clysmic.com

unit HelpTst_f;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, IniFiles;

type
  THelpTstForm = class(TForm)
    HelpList: TListBox;
    Label1: TLabel;
    NotFoundList: TListBox;
    Label2: TLabel;
    DelBtn: TButton;
    ExitBtn: TButton;
    AboutBtn: TButton;
    procedure FormCreate(Sender: TObject);
    procedure DelBtnClick(Sender: TObject);
    procedure ExitBtnClick(Sender: TObject);
    procedure AboutBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure LoadLists(Sender: TObject);
  end;

var
  HelpTstForm: THelpTstForm;

{----------------------------------------------------------------------}

implementation

{$R *.DFM}

{----------------------------------------------------------------------}

procedure THelpTstForm.LoadLists(Sender: TObject);

Var
  HIni : TIniFile;
  i : Integer;
  SecnList : TStringList;

begin
  { Empty the lists }
  HelpList.Clear;
  NotFoundList.Clear;
  
  { Get section of name=value }
  HIni := TIniFile.Create('winhelp.ini');
  SecnList := TStringList.Create;
  HIni.ReadSectionValues('files',SecnList);

  For i := 0 to SecnList.Count-1 Do
    HelpList.Items.Add(SecnList.Values[SecnList.Names[i]]+'\'+SecnList.Names[i]);

  HIni.Free;

  For i := 0 to HelpList.Items.Count-1 Do
  Begin
    If Not FileExists(HelpList.Items.Strings[i])
      Then NotFoundList.Items.Add(HelpList.Items.Strings[i]);
  End;

  { Can't delete what isn't there }
  If NotFoundList.Items.Count = 0
    Then DelBtn.Enabled := False;
end;

{----------------------------------------------------------------------}

procedure THelpTstForm.FormCreate(Sender: TObject);

begin
  LoadLists(Sender);
end;

{----------------------------------------------------------------------}

procedure THelpTstForm.DelBtnClick(Sender: TObject);

Var
  HIni : TIniFile;
  i : Integer;
  Tx : String;
  FName1,FName2 : Array [0..265] of Char;

begin
  { Backup WINHELP.INI }
  GetWindowsDirectory(FName1,SizeOf(FName1));
  StrCopy(FName2,FName1);
  StrCat(FName1,'\WINHELP.INI');
  StrCat(FName2,'\WINHELP.BAK');
  CopyFile(FName1,FName2,True);

  MessageBox(HelpTstForm.Handle,'Your WINHELP.INI File has been backed up ' +
             'as WINHELP.BAK','WINHELP.INI Resolver Message',mb_ok or mb_IconInformation);

  { Open ini file again }
  HIni := TIniFile.Create('winhelp.ini');

  { Go thru the list of not found files }
  For i := 0 to NotFoundList.Items.Count-1 Do
  Begin
    { Get just the filename (no path) }
    Tx := ExtractFileName(NotFoundList.Items.Strings[i]);

    { Delete that entry from the INI }
    HIni.DeleteKey('files',Tx);
  End;

  HIni.Free;

  { Update list boxes }
  LoadLists(Sender);
end;

{----------------------------------------------------------------------}

procedure THelpTstForm.ExitBtnClick(Sender: TObject);
begin
  Application.Terminate;
end;

procedure THelpTstForm.AboutBtnClick(Sender: TObject);
begin
  MessageBox(HelpTstForm.Handle,
    'WINHELP.INI Reference Resolver' + #13#13 +
    'Unsupported freeware' + #13 +
    'Copyright 1996 by Ralph Smith. All rights reserved.' + #13#13 +
    'e-mail: rsmith@clysmic.com',
    'About',mb_ok or mb_IconInformation);
end;

end.
//


